<?php
/**
 * Magento
 * @category   Payment
 * @package    Pdt_mabna
 * @copyright  Copyright (c) 2015 softiran.org
 * @see http://softiran.org
 */
class Pdt_Mabna_Block_Redirect extends Mage_Core_Block_Template
{
    /**
     * Return checkout session instance
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }

    /**
     * Return order instance
     *
     * @return Mage_Sales_Model_Order|null
     */
    protected function _getOrder()
    {
        if ($this->getOrder()) {
            return $this->getOrder();
        } elseif ($orderIncrementId = $this->_getCheckout()->getLastRealOrderId()) {
            return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
        } else {
            return null;
        }
    }

    /**
     * Get form data
     *
     * @return array
     */
    public function getFormData()
    {

		$order = $this->_getOrder()->_data;
		$array = $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
		$price = $array["price"];
				
		$terminal = $this->_getOrder()->getPayment()->getMethodInstance()->getConfigData('seller_id');	

		$amount = round($order["grand_total"],0);
		
		if( strtoupper(Mage::app()->getStore()->getCurrentCurrencyCode()) == 'IRT')
			$amount = $amount * 10;
		
		$callBackUrl = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK);
		$callBackUrl .= "mabna/processing/response/";
		$redirectAddress = $callBackUrl;
		$invoiceNumber = time();

		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$params = array(
                'TerminalID' => $terminal,
                'token' => $res['Accesstoken']
              );
			  return $params;
			}else
			{
				return('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
			}
		}
		else
		{
			return('پورت 8081 در هاست شما بسته است !');
		}
					
	
    }

    /**
     * Getting gateway url
     *
     * @return string
     */
    public function getFormAction()
    {
    		   
		return 'https://mabna.shaparak.ir:8080';
		
    }
}
