<?php
/**
 * Magento
 * @category   Payment
 * @package    Pdt_mabna
 * @copyright  Copyright (c) 2015 softiran.org
 * @see http://softiran.org
 */
class Pdt_Mabna_ProcessingController extends Mage_Core_Controller_Front_Action
{
    protected $_successBlockType  = 'mabna/success';
    protected $_failureBlockType  = 'mabna/failure';

    protected $_order = NULL;
    protected $_paymentInst = NULL;


    /**
     * Get singleton of Checkout Session Model
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }
	public function mkzero($z){
		$str = "1";
		while($z > 0){
			$str .= "0";
			$z -= 1;
		}
		return $str;	
	} 
    public function redirectAction()
    {
        try {
            $session = $this->_getCheckout();

            $order = Mage::getModel('sales/order');
            $order->loadByIncrementId($session->getLastRealOrderId());
            if (!$order->getId()) {
                Mage::throwException('No order for processing found');
            }
            if ($order->getState() != Mage_Sales_Model_Order::STATE_PENDING_PAYMENT) {
                $order->setState(
                    Mage_Sales_Model_Order::STATE_PENDING_PAYMENT,
                    $this->_getPendingPaymentStatus(),
                    Mage::helper('mabna')->__('Customer was redirected to mabna gateway.')
                )->save();
            }

            if ($session->getQuoteId() && $session->getLastSuccessQuoteId()) {
                $session->setClickandbuyQuoteId($session->getQuoteId());
                $session->setClickandbuySuccessQuoteId($session->getLastSuccessQuoteId());
                $session->setClickandbuyRealOrderId($session->getLastRealOrderId());
                $session->getQuote()->setIsActive(false)->save();
                $session->clear();
            }

            $this->loadLayout();
            $this->renderLayout();
            return;
        } catch (Mage_Core_Exception $e) {
            $this->_getCheckout()->addError($e->getMessage());
        } catch(Exception $e) {
            Mage::logException($e);
        }
		
		
        //$this->_redirect('checkout/cart');
    }
    public function responseAction()
    {

		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{

			$session = $this->_getCheckout();
			
			$orderid = $session->getClickandbuyRealOrderId();
			
			$this->_order = Mage::getModel('sales/order')->loadByIncrementId($orderid);			
			$this->_paymentInst = $this->_order->getPayment()->getMethodInstance();
			
			$quote = $orderid = $this->_order->getData();
			$price = $quote["grand_total"] ;
			
			if( strtoupper(Mage::app()->getStore()->getCurrentCurrencyCode()) == 'IRT')
				$price = $price * 10;
			
			$terminal = $this->_paymentInst->getConfigData('seller_id');

		
			
			$mageFilename = 'app/Mage.php';
			require_once $mageFilename;
			Mage::setIsDeveloperMode(true);

			Mage::app();

			$connection = Mage::getSingleton('core/resource')->getConnection('core_read');
			$query = $connection->select()->from('sales_payment_transaction')->where('txn_id=?', $_POST['digitalreceipt']);
			$rows       = $connection->fetchRow($query);
			if(!$rows )
			{
		
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
				
				if (strtoupper($result['Status']) == 'OK') 
				{
					
					if(floatval($result['ReturnId']) == floatval($price))
					{
						$referenceId = $_POST['digitalreceipt'];
						
						$this->_order->getPayment()->setTransactionId($referenceId);
						$this->_order->getPayment()->setLastTransId($referenceId);
						

						if ($this->_order->canInvoice()) {
							$invoice = $this->_order->prepareInvoice();
							$invoice->register()->capture();
							Mage::getModel('core/resource_transaction')
								->addObject($invoice)
								->addObject($invoice->getOrder())
								->save();
						}
			

						$this->_order->addStatusToHistory($this->_paymentInst->getConfigData('order_status'), Mage::helper('mabna')->__('Payment complete'));
			

						$this->_order->sendNewOrderEmail();
						$this->_order->setEmailSent(true);
			
						$this->_order->save();
			

						$this->getResponse()->setBody(
							$this->getLayout()
								->createBlock($this->_successBlockType)
								->setOrder($this->_order)
								->toHtml());
					}
					else
					{
						$this->_redirect('mabna/processing/caberror');
					}
					
				}else
				{
					$this->_redirect('mabna/processing/caberror');
				}			
			}
			else
			{
				$this->_redirect('mabna/processing/caberror');
			}
		}
		else
		{
			$this->_redirect('mabna/processing/caberror');
		}
    }
    public function successAction()
    {
        try {
            $session = $this->_getCheckout();
            $session->unsClickandbuyRealOrderId();
            $session->setQuoteId($session->getClickandbuyQuoteId(true));
            $session->setLastSuccessQuoteId($session->getClickandbuySuccessQuoteId(true));
            $this->_redirect('checkout/onepage/success');
            return;
        } catch (Mage_Core_Exception $e) {
            $this->_getCheckout()->addError($e->getMessage());
        } catch(Exception $e) {
            Mage::logException($e);
        }
        $this->_redirect('checkout/cart');
    }

    /**
     * ClickandBuy sub error action
     */
    public function caberrorAction()
    {
        // set quote to active
        $session = $this->_getCheckout();
        if ($quoteId = $session->getClickandbuyQuoteId()) {
            $quote = Mage::getModel('sales/quote')->load($quoteId);
            if ($quote->getId()) {
                $quote->setIsActive(true)->save();
                $session->setQuoteId($quoteId);
            }
        }

        $this->getResponse()->setBody(
            $this->getLayout()
                ->createBlock($this->_failureBlockType)
                ->setOrder($this->_order)
                ->toHtml()
        );
    }

    /**
     * ClickandBuy sub success action
     */
    public function cabsuccessAction()
    {
       
    }


    protected function _getPendingPaymentStatus()
    {
        return Mage::helper('mabna')->getPendingPaymentStatus();
    }
}
